/************************************************
* FL.C - see how many open files we can have	*
*												*
* 900420 MCMason: originally written (MSC 5.1)	*
************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>

#define TEST_SIZE 32

#ifdef CASE
#  if CASE == 1
#	 define TABLE_HDR "Normal startup code"
#  elif CASE == 2
#	 define TABLE_HDR "Modified CRT0DAT"
#  elif CASE == 3
#	 define TABLE_HDR "Modified CRT0DAT & _FILE"
#  endif
#else
=z;	/* syntax error to 'remind' user to use the	*/
	/* batch file to create the executable file	*/
#endif

int handles[TEST_SIZE];
FILE *files[TEST_SIZE];
char  wbuf[20];

void main(void)
	{
	int i;

	/*******************************************
	* Open, close & delete files using handles *
	*******************************************/
	for (i=0; i<TEST_SIZE; i++)
		{
		sprintf(wbuf,"HANDLFL.%03d",i);
		handles[i]=open(wbuf,O_CREAT,S_IWRITE);
		}
	for (i=0; i<TEST_SIZE; i++)
		if (handles[i] != -1)
			{
			close(handles[i]);
			sprintf(wbuf,"HANDLFL.%03d",i);
			unlink(wbuf);
			}

	/*******************************************
	* Open, close & delete files using streams *
	*******************************************/
	for (i=0; i<TEST_SIZE; i++)
		{
		sprintf(wbuf,"STREAMFL.%03d",i);
		files[i]=fopen(wbuf,"w");
		}
	for (i=0; i<TEST_SIZE; i++)
		if (files[i] != NULL)
			{
			fclose(files[i]);
			sprintf(wbuf,"STREAMFL.%03d",i);
			unlink(wbuf);
			}

	/*****************************
	* Print the table of results *
	*****************************/
	printf(	TABLE_HDR
			"\nfilnum   handle   stream"
			"\n------   ------   ------");
	for (i=0; i<TEST_SIZE; i++)
		{
		printf("\n  % 3d    %s   %s",i+1,
			(handles[i]==-1)?"FAILED":"OPENED",
			(files[i]==NULL)?"FAILED":"OPENED");
		}
	}
